'-- uni8ad_fb.bas ---------------------------------------------- >>fst'12<< -
' - liest den Universal 8-Bit AD Wandler per "Bitbanging" aus
' - nutzt WinAPI zur Ansteuerung der seriellen Schnittstelle
'   sollte deshalb auch mit USB-seriell Adaptern funktionieren
' - Compiler: FreeBasic 
' - Verbindungen: (Bauanleitung im Internet; s.u.)
'   - TLC549 -       - COM -  - Zweck ---------------------------
'   VCC         <-     TxD    Versorgungsspannung fuer Platine
'   I/O Clock   <-     DTR    Taktleitung
'   DATA OUT    ->     CTS    Daten vom Wandler
'   CS          <-     RTS    Wandler-Aktivierung (Chip-Select)
'-- V 20120318 ------------------------------- http://www.FrankSteinberg.de -

#INCLUDE ONCE "windows.bi"

Dim Ref As Single  = .256      '<- hier am uni8ad eingestellte Referenzspannung angeben
Dim hCom As handle             'Handle des Comports
Dim modemStat As dword         'Rckgabewert der Eingangsleitungen
Dim PortNr As String = "COM1"  'Nummer des Comports (COM1 - COM256 mglich)
Dim EW As Integer              'einzelner Messwert 
Dim U As Single                'Messwert als Spannung
Dim As Integer i, j            'Zhlvariablen

'Serielle Schnittstelle ffnen:
hCom = CreateFile("//./"+PortNr, GENERIC_READ Or GENERIC_WRITE, 0, NULL, OPEN_EXISTING, 0, NULL)
'Fehlerbehandlung, falls ffnen fehlschlgt:
If hCom = INVALID_HANDLE_VALUE Then
  MessageBox 0,"Fehler beim ffnen von  " & PortNr,"uni8ad    >>fst'12<<", MB_ICONERROR
  End
End If

'Steuerleitungen low:
EscapeCommFunction(hCom, CLRRTS)    'RTS -12V  CS low
EscapeCommFunction(hCom, CLRDTR)    'DTR -12V  Clock low

'Stromversorgung des Wandlers an TxD -> VSS einschalten:
EscapeCommFunction(hCom, SETBREAK)

PRINT
PRINT "Universal 8-Bit AD-Wandler    >>fst'12<<"
Print " - Ende mit [Esc] -"
Print
PRINT "Schnittstelle    = "; PortNr
Print "Referenzspannung ="; Ref; "Volt"

DO                                          'Beginn der Hauptschleife
 
  Sleep(9)                                  'kurz warten
  EscapeCommFunction(hCom, SETRTS)          'RTS +12V  CS high
  Sleep(9)                                  'kurz warten
  EscapeCommFunction(hCom, CLRRTS)          'RTS -12V  CS low
  EW = 0                                    'Messwert auf Null
   FOR j = 7 TO 0 STEP -1                   '8 Bits fuer einen Wert, MSB zuerst
    Sleep(9)                                'kurz warten
    GetCommModemStatus(hCom, @modemStat)    'Eingnge vom Comport lesen
    'Zustand von CTS (=DATA OUT) lesen und auswerten:
    IF (modemStat And MS_CTS_ON) THEN EW = EW + 2 ^ j
    EscapeCommFunction(hCom, SETDTR)        'DTR +12V  CLK high
    Sleep(9)                                'kurz warten
    EscapeCommFunction(hCom, CLRDTR)        'DTR -12V  CLK low
   NEXT j                                   'naechstes Bit
  
  'Wert anzeigen:
  LOCATE 10
  PRINT USING "Messwert    ###  Digits"; EW
  PRINT
  U = EW * Ref / 256                        'Messspannung berechnen
  PRINT USING "Spannung  #.###  Volt "; U
 
  'Sleep(400)
 
LOOP WHILE INKEY$ = ""                      'Ende bei Tastendruck

'Serielle Schnittstelle schlieen:
closeHandle(hCom)
